;;;;;;;;;;;;;;;;;;;;;;
;Pong Extreme;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;

;set up the constants....
Const g_width  = 1024 		;screen width
Const g_height = 768  		;screen height
Const up       = 200  		;the scancode for the up key
Const down     = 208  		;the scancode for the down key
Const fps#     = 60   		;how many frames per senond
Global period   = 1000/fps#  
Global timer    = MilliSecs()

;---------------------------------------------------------------------
;==========================*PRE-GAME SET UP*==========================
;---------------------------------------------------------------------

Graphics g_width, g_height,0,1 ;set the graphics mode
AppTitle "Pong: Extreme"
SetBuffer BackBuffer() ;enable flipping
SeedRnd(MilliSecs()) ;seed random generator

;Include "particle_lib.bb"

;---------------------------------------------------------------------

;======Variables======

Global win = 0
Global boss_ini = 0
Global skip=0 

Type star
	Field x,y,xv#,yv#,q
	Field a#,c,mc
	Field size#
	Field xacc#,yacc#
End Type

Const numofstars = 1 ;;the number of stars created PER FRAME
timer = CreateTimer(60)
Global num = 10
Global load_time = MilliSecs()+Rand(3000,7000) 

Global s_x# = g_width/2			;start button X value
Global s_y = g_height/2 +70	;start button Y value
Global s_f = 0					;start button's frame
Global e_x# = g_width/2			;exit button X value
Global e_y = g_height/2 + 300	;exit button Y value
Global e_f = 0					;exit button's frame
Global t_x = g_width/2
Global t_y = 550
Global t_f = 0

Global start_button = 0				 	 ;whether start button has been pressed or not
Global exit_button  = 0				 	 ;whether exit button has been pressed or not
Global two_button = 0

Global score_diff = 0				;how many points you have to be ahead by to go to the boss

Global screeny_num


Global player_x = (g_width - 54) ;player's x value
Global player_y = 384			 ;player's y value
Global player_s = 5				 ;player's speed
Global player_l = 10			 ;player's lives
Global player_sc = 0			 ;player's score 

Global enemy_x = 30				 ;enemy's x value
Global enemy_y = 384			 ;enemy's y value
Global enemy_s = 5				 ;enemy's speed
Global enemy_l = 100			 ;enemy's lives
Global enemy_h = Rand(1,3)		 ;enemy's hit percentage
Global enemy_sc = 0				 ;enemy's score

Global BallX = 0
Global BallY = 0
Global BallXIncrement = 3
Global BallYIncrement = 2

Global star_y = 0

Global credits_show = 1


Global SnapITC = LoadFont("SnapITC",35,0,0,0)

;======Load Images======

Global ball   = LoadImage("graphics\ball.png")                 ;load the ball's image
Global player = LoadAnimImage("graphics\player.png",20,80,0,13)			   ;load the player's image
Global enemy  = LoadImage("graphics\enemy.png")				   ;load the enemy's image
Global boss_image   = LoadImage("graphics\boss.png")

Global mouse  = LoadImage("graphics\mouse.png")				 ;loads the mouse

Global s_bttn = LoadAnimImage("graphics\start_button.png",198,50,0,2)	   ;load start button image
Global e_bttn = LoadAnimImage("graphics\exit_button.png",136,49,0,2)		   ;load exit button image
Global t_bttn = LoadAnimImage("graphics\two_player_button.png",304,77,0,2)	;load the rwo player button

Global title_screen = LoadImage("graphics\title_screen.png")   ;load the title screen

Global star_close = LoadImage("graphics\stars.png")  
Global star_far = LoadImage("graphics\stars_far.png")

Global ss_logo = LoadImage("graphics\ss_logo.png")

Global controls = LoadImage("graphics\controls.png")

Global credit_image = LoadImage("graphics\credits.png")

Global boss_intro = LoadImage("graphics\boss_intro.png")

Global boss_lose = LoadImage("graphics\boss_lose.png")


MaskImage t_bttn,192,192,192
MaskImage s_bttn,192,192,192
MaskImage e_bttn,192,192,192
MaskImage mouse,192,192,192
MaskImage player,0,255,0


;======End Images======

;======Load Music/Sounds======

Global collide = LoadSound("sound\BEEBIT.wav")		   ;wall collide sound effect
Global click   = LoadSound("sound\BUTTON1.wav")		   ;click sound effect
Global score   = LoadSound("sound\KLING.wav")		   ;score sound effect
Global explo   = LoadSound("sound\explosion.wav")	   ;explosion sfx

;======End sounds======


;======Types======

;The player's type

Type player     ;the name of the type
	Field x,y   ;the player's x and y position
	Field speed ;the player's speed
	Field lives ;the player's lives
	Field score ;the player's score
	Field frame
End Type

Global p.player = New player ;create the player type
p\x = player_x
p\y = player_y
p\speed = player_s
p\lives = player_l
p\score = player_sc
p\frame = 0

;The enemy's type

Type enemy      ;the name of the type
	Field x,y   ;the enemy's x and y position
	Field speed ;the enemy's speed
	Field lives ;the enemy's lives
	Field hit   ;the enemy's hit percentage
	Field score ;the enemy's score
End Type

Global e.enemy = New enemy ;create the enemy type
e\x = enemy_x
e\y = enemy_y
e\speed = enemy_s
e\lives = enemy_l
e\hit = enemy_h
e\score = enemy_sc


;The ball's type

Type ball       ;the name of the type
	Field x,y   ;the ball's x and y position
	Field speed ;the ball's speed
	Field x_speed
	Field y_speed
End Type


Global b.ball = New ball
b\x = 512
b\y = 384
b\x_speed = Rand(-5,5)
b\y_speed = Rand(-5,5)


Type particles ;a type for the particles
	Field x#,y# ;x,y positions
	Field dx#,dy# ;direction
	Field r#,g#,b# ;colour
	Field a# ;alpha
End Type

Type boss
	Field x
	Field y
	Field speed
	Field hit
	Field lives
	Field score
End Type

Global boss.boss = New boss

boss\x = enemy_x
boss\y = enemy_y
boss\lives = 1
boss\speed = 10
boss\hit = enemy_h
boss\score = 0



SoundVolume collide,0.2
SoundVolume score,0.2

MoveMouse(512,300)
.loop

title = PlayMusic("sound\bg_title.mid")
Repeat
Cls
draw_title_screen()
Flip
Until start_button = 1 

StopChannel(title)

create_lines()


;---------------------------------------------------------------------
;==========================*MAIN GAME LOOP*===========================
;---------------------------------------------------------------------

SoundVolume collide,1.0
main = PlayMusic("sound\bg_main_compressed_and_sliced.mp3")

While Not KeyHit(1)
Cls



particles(b\x+(ImageWidth(ball)/2),b\y+(ImageHeight(ball)/2),0,Rand(0,255),255,2)
update_particles()
render_background()
render_player()
update_player()
render_enemy()
update_enemy()
render_ball()
ball_collisions()
drawHUD()
update_ball()
pause()
controls_window()
screenshot()
boss()


Flip
Wend

End
;---------------------------------------------------------------------
;==============================*FUNCTIONS*============================
;---------------------------------------------------------------------

;======Title Screen======

Function draw_title_screen()

	DrawImage(title_screen,0,0) ;draws the title screen image
	DrawImage(s_bttn,s_x -(ImageWidth(s_bttn)/2),s_y,s_f) 				 ;draws the start button
	DrawImage(e_bttn,e_x-(ImageWidth(e_bttn)/2)	,e_y,e_f)				 ;draws the exit button
	DrawImage(t_bttn,t_x-(ImageWidth(t_bttn)/2),t_y,t_f)					 
	DrawImage(ss_logo,740,490)
	DrawImage(mouse,MouseX(),MouseY())

	
If MouseHit(1)
	If MouseX() => s_x-(ImageWidth(s_bttn)/2) And MouseY() => s_y And MouseX() <= (s_x+ImageWidth(s_bttn)) And MouseY() <= (s_y+ImageHeight(s_bttn))
		start_button = 1
		PlaySound click
		Cls
	EndIf
		;checking if the start button has been pressed


	If MouseX() >= e_x-(ImageWidth(e_bttn)/2) And MouseY() >= e_y And MouseX() <= (e_x+ImageWidth(e_bttn)) And MouseY() <= (e_y+ImageHeight(e_bttn))
		exit_button = 1
		PlaySound click
	EndIf
		;checking if the quit button has been pressed

If MouseX() => t_x-(ImageWidth(t_bttn)/2) And MouseY() => t_y And MouseX() <= (t_x+ImageWidth(t_bttn)) And MouseY() <= (t_y+ImageHeight(t_bttn))
		two_button = 1
		start_button = 1
		PlaySound click
		Cls
	EndIf
EndIf


If exit_button = 1 
	End
EndIf


If MouseX() => s_x And MouseY() => s_y And MouseX() <= (s_x+ImageWidth(s_bttn)) And MouseY() <= (s_y+ImageHeight(s_bttn))
	s_f = 1
	Else
	s_f = 0
EndIf

If MouseX() >= e_x And MouseY() >= e_y And MouseX() <= (e_x+ImageWidth(e_bttn)) And MouseY() <= (e_y+ImageHeight(e_bttn))
	e_f = 1
	Else
	e_f = 0
EndIf

If MouseX() => t_x And MouseY() => t_y And MouseX() <= (t_x+ImageWidth(t_bttn)) And MouseY() <= (t_y+ImageHeight(t_bttn))
	t_f = 1
	Else	
	t_f =0	
EndIf	


End Function ;end of the draw_title_screen() function

;======Title Screen Finish=====

;======Render Player======

Function render_player()


	DrawImage(player,p\x,p\y)

	
End Function 

;======Render Player Finish======

;======Render Enemy======

Function render_enemy()


	DrawImage(enemy,e\x,e\y)

	
End Function

;======Render Enemy Finish======

;======Update Player======

Function update_player()

	If KeyDown(up)			;if up key pressed
		p\y = p\y - p\speed ;move player up
ElseIf KeyDown(down)		;if down key pressed
		p\y = p\y + p\speed ;move player down
EndIf

If p\y >= g_height-ImageHeight(player)
	p\y = g_height-ImageHeight(player)
ElseIf p\y <= 0
	p\y = 0
EndIf
	
End Function

Function update_player_boss()

	If KeyDown(up)			;if up key pressed
		p\y = p\y - p\speed ;move player up
ElseIf KeyDown(down)		;if down key pressed
		p\y = p\y + p\speed ;move player down
EndIf

If p\y >= g_height-ImageHeight(player)
	p\y = g_height-ImageHeight(player)
ElseIf p\y <= 0
	p\y = 0
EndIf

If p\frame >= 10 Then 
	p\frame = 10
	p\lives = 0
EndIf

If win = 0
If p\lives = 0 Then
	Cls
	DrawImage boss_lose,g_width/2-(ImageWidth(boss_lose)/2),g_height/2-(ImageHeight(boss_lose)/2)
	Flip
	Delay 500
	FlushMouse()
	WaitMouse()
	Cls
	SetFont SnapITC
	Color 255,255,255
	Text g_width/2,g_height/2,"You have been defeated ='(",1,1
	Text g_width/2,g_height/2+200,"Click the mouse to end your torment...",1,1
	Delay 500
	FlushMouse()
	WaitMouse()
	End
	EndIf
EndIf
				
End Function

;======Update Player Finish======

;======Update Enemy======

Function update_enemy()

If two_button = 0
	If b\y > e\y 
		If e\hit > 2
			e\y = e\y + e\speed
			Else 
			e\y = e\y
			e\hit = Rand(1,5)
		EndIf
	EndIf
EndIf



If two_button = 0
If b\y < e\y 
		If e\hit > 2
			e\y = e\y - e\speed
			Else
			e\y = e\y
			e\hit = Rand(1,5)
		EndIf
	EndIf
EndIf

If e\y <= 0
	e\y = 0
EndIf

If e\y >= g_height + ImageHeight(enemy)
	e\y = g_height + ImageHeight(enemy)
EndIf

If e\speed >= 5
	e\speed = 5
EndIf

If two_button = 1
If KeyDown(42) ;left shift
	e\y = e\y - e\speed
ElseIf KeyDown(29) ;left control
	e\y = e\y + e\speed
EndIf
EndIf


End Function

Function update_boss()

If two_button = 0
	If b\y > boss\y 
		If boss\hit > 2
			boss\y = boss\y + boss\speed
			Else 
			boss\y = boss\y
			boss\hit = Rand(1,5)
		EndIf
	EndIf
EndIf



If two_button = 0
If b\y < boss\y 
		If boss\hit > 2
			boss\y = boss\y - boss\speed
			Else
			boss\y = boss\y
			boss\hit = Rand(1,5)
		EndIf
	EndIf
EndIf

If boss\y <= 0
	boss\y = 0
EndIf

If boss\y >= g_height + ImageHeight(boss_image)
	boss\y = g_height + ImageHeight(boss_image)
EndIf

If boss\speed >= 5
	boss\speed = 5
EndIf

If two_button = 1
If KeyDown(42) ;left shift
	e\y = e\y - e\speed
ElseIf KeyDown(29) ;left control
	e\y = e\y + e\speed
EndIf
EndIf

If win = 0
If boss\score = 2 Then
	Cls
	DrawImage boss_lose,g_width/2-(ImageWidth(boss_lose)/2),g_height/2-(ImageHeight(boss_lose)/2)
	Flip
	Delay 500
	FlushMouse()
	WaitMouse()
	Cls
	SetFont SnapITC
	Color 255,255,255
	Text g_width/2,g_height/2,"You have been defeated ='(",1,1
	Text g_width/2,g_height/2+200,"Click the mouse to end your torment...",1,1
	Delay 500
	FlushMouse()
	WaitMouse()
	End
	EndIf
EndIf

End Function


;======Update Enemy Finish======

;======Render Ball======

Function render_ball()

	If e\lives Or p\lives > 0 
	
		DrawImage(ball,b\x,b\y)
	EndIf


End Function 

;======Render Ball Finish======

;======Ball Collisions======

Function ball_collisions()

	If ImagesCollide(ball,b\x,b\y,0,enemy,e\x,e\y,0)
		b\x_speed = -b\x_speed+1 - Rand(-2,2)
		PlaySound collide
ElseIf ImagesCollide(ball,b\x,b\y,0,player,p\x,p\y,0)
		b\x_speed = -b\x_speed-1 + Rand(-2,2)
		PlaySound collide
ElseIf b\y <= 0
		b\y_speed = -b\y_speed - Rand(-1,-2)
		PlaySound collide
ElseIf b\y >= g_height - ImageHeight(ball)
		b\y_speed = -b\y_speed - Rand(1,3)
		PlaySound collide
ElseIf b\x <= 0
		b\x_speed = -b\x_speed+1
		b\y_speed = b\y_speed + Rand(-1,1)	
	 b\x = 15
		PlaySound score
		p\score = p\score + 1
		score_diff = score_diff - 1
		
ElseIf b\x >= g_width - ImageWidth(ball)
		b\x_speed = -b\x_speed-1
		b\y_speed = b\y_speed + Rand(-1,1)
	b\x = g_width - 20
		PlaySound score
		e\score = e\score + 1
		score_diff = score_diff + 1

EndIf		
	

If b\x_speed > 5
	b\x_speed = 5
EndIf

If b\y_speed >5
	b\y_speed = 5
EndIf

If b\y_speed = 0 Then b\y_speed = b\y_speed + 2
If b\x_speed = 0 Then b\x_speed = b\x_speed + 2

End Function

Function ball_collisions_boss()

	If ImagesCollide(ball,b\x,b\y,0,boss_image,boss\x,boss\y,0)
		b\x_speed = -b\x_speed+1 - Rand(-2,2)
		PlaySound collide
ElseIf ImagesCollide(ball,b\x,b\y,0,player,p\x,p\y,p\frame)
		b\x = b\x - 5
		b\x_speed = -b\x_speed-1 + Rand(-2,2)
		PlaySound explo
		p\frame = p\frame + 1 : p\lives = p\lives - 1
ElseIf b\y <= 0
		b\y_speed = -b\y_speed - Rand(-1,-2)
		PlaySound collide
ElseIf b\y >= g_height - ImageHeight(ball)
		b\y_speed = -b\y_speed - Rand(1,3)
		PlaySound collide
ElseIf b\x <= 0
		b\x_speed = -b\x_speed+1
		b\y_speed = b\y_speed + Rand(-1,1)	
	 b\x = 15
		PlaySound score
		p\score = p\score + 1
		boss\lives = 0
		credits_boss()		
ElseIf b\x >= g_width - ImageWidth(ball)
		boss\score = boss\score+1
		b\x_speed = -b\x_speed-1
		b\y_speed = b\y_speed + Rand(-1,1)
		b\x = g_width - 20
		PlaySound score
		


EndIf		

	

If b\x_speed > 5
	b\x_speed = 5
EndIf

If b\y_speed >5
	b\y_speed = 5
EndIf

If b\y_speed = 0 Then b\y_speed = b\y_speed + 2
If b\x_speed = 0 Then b\x_speed = b\x_speed + 2

End Function

;======Ball Collisions Finish======
		
;======Draw the HUD======

Function drawHUD()

If two_button = 0
	SetFont SnapITC
	Color 255,255,255
	Text 0,0,"Press 'enter' for controls",0,0
	
	Text 350,50,"player score: "+p\score,1,1
	
	Text 512,50,"["+score_diff+"]",1,1
	
	Text 674,50,"enemy score: "+e\score,1,1

Else

	SetFont SnapITC
	Color 255,255,255
	Text 0,0,"Press 'enter' for controls"
	
	Text 350,50,"Player 1  score: [ "+p\score+" ]",1,1
	
	Text 512,50,"|",1,1
	
	Text 674,50,"Player 2  score: [ "+e\score+" ]",1,1
EndIf
	
End Function

Function draw_boss_HUD()

SetFont SnapITC
Color 255,255,255
Text 0,0,"Defeat the boss before his Power Ball breaks you!"
Text 512,50,"Hits until you break: "+p\lives
Text 800,0,"Boss score: " + boss\score

End Function


;======Draw HUD Finish======



;======Update Ball======

Function update_ball()

	If start_button = 1
		b\x = b\x + b\x_speed
		b\y = b\y + b\y_speed
EndIf

End Function

;======Update Ball Finish======

Function initialize()

	p\x = 970
	p\y = 384
	
	e\x = 54
	e\y = 384
	e\hit = Rand(1,3)
	
	b\x = 512
	b\y = 384
	
	b\x_speed = Rand(1,5)
	b\y_speed = Rand(1,5)
	
End Function

;======Background======

Function render_background()

	TileImage star_close,0,star_y
	TileImage star_far,0,star_y*2

	
star_y = star_y + 1

If star_y >= ImageHeight(star_close)
	star_y = 0
EndIf

End Function

;======Background Finish======

;======Pause======

Function pause()

Color Rand(255),Rand(100),Rand(255)
	If KeyHit(57)
		
		Text 512,384,"Game Paused. Press spacebar to unpause game",1,1
		
		Flip
	While Not KeyHit(57)
	Wend
EndIf

End Function

Function controls_window()

	If KeyHit(28)
	
		DrawImage controls,g_width/2 - (ImageWidth(controls)/2),g_height/2-(ImageHeight(controls)/2)
		
		Flip
		While Not KeyHit(28)
		Wend
	EndIf
	
End Function

Function credits()

Local credit_y# = 768

If two_button = 0


If win_diff = p\score - e\score
	If credits_show = 1
	
		While Not KeyHit(1)
			Cls
			
			update_particles()
			
	
		If Not skip 
	For whatever = 0 To numofstars 
		s.star = New star
		s\x = (GraphicsWidth()/2)+Rand(-20,20) : s\y = (GraphicsHeight()/2)+Rand(-20,20)
		s\q = Quadrant(s\x,s\y)
		If s\q
			Select s\q
				Case 1
					s\a# = Rnd#(90,180)
				Case 2
					s\a# = Rnd#(0,90)
				Case 3
					s\a# = Rnd#(270,360)
				Case 4
					s\a# = Rnd#(180,270)
			End Select
		Else
			s\a# = Rnd#(0,359) 
		EndIf
					
		s\xv# = Sin#(s\a#)*Rand(2,8) : s\yv# = Cos#(s\a#)*Rand(2,8)
		s\mc = 6 * (((Abs(s\xv+s\yv)))*10)
		If s\mc > 255 Then s\mc = 255
		s\c = 100 : s\size# = 1 
	Next
	EndIf 
		
	For s.star = Each star
		
		s\x = s\x + s\xv# : s\y = s\y + s\yv#
		If s\c <= s\mc Then s\c = s\c + 7 Else s\c = s\mc
		s\size# = s\size# + (0.05*((Distance(GraphicsWidth()/2,GraphicsHeight()/2,s\x,s\y)-100)/285))
		If s\size# > 2 Then s\size# = 2
		
		s\c = Int(s\c)
		
		Color s\c,s\c,s\c
		Line s\x,s\y,s\x+s\xv/2,s\y+s\yv/2;s\size#,s\size#
		
		If s\x < 0 Or s\x > GraphicsWidth() Or s\y < 0 Or s\y > GraphicsHeight() Then Delete s
	Next
	WaitTimer(timer)
	
DrawImage credit_image,70,credit_y#
		credit_y# = credit_y# - 0.5

		
		

		
		particles(512,384,Rand(255),Rand(255),Rand(255),10)
				
		
			Flip
		Wend
		credits_show = 0
		EndIf
	EndIf
EndIf

If credits_show = 0
	End
EndIf



End Function

Function credits_boss()


Local credit_y# = 768

If two_button = 0

If boss\lives = 0

	If credits_show = 1
		win = 1
		
		While Not KeyHit(1)
			Cls
			
			update_particles()
			
	
		If Not skip 
	For whatever = 0 To numofstars 
		s.star = New star
		s\x = (GraphicsWidth()/2)+Rand(-20,20) : s\y = (GraphicsHeight()/2)+Rand(-20,20)
		s\q = Quadrant(s\x,s\y)
		If s\q
			Select s\q
				Case 1
					s\a# = Rnd#(90,180)
				Case 2
					s\a# = Rnd#(0,90)
				Case 3
					s\a# = Rnd#(270,360)
				Case 4
					s\a# = Rnd#(180,270)
			End Select
		Else
			s\a# = Rnd#(0,359) 
		EndIf
					
		s\xv# = Sin#(s\a#)*Rand(2,8) : s\yv# = Cos#(s\a#)*Rand(2,8)
		s\mc = 6 * (((Abs(s\xv+s\yv)))*10)
		If s\mc > 255 Then s\mc = 255
		s\c = 100 : s\size# = 1 
	Next
	EndIf 
		
	For s.star = Each star
		
		s\x = s\x + s\xv# : s\y = s\y + s\yv#
		If s\c <= s\mc Then s\c = s\c + 7 Else s\c = s\mc
		s\size# = s\size# + (0.05*((Distance(GraphicsWidth()/2,GraphicsHeight()/2,s\x,s\y)-100)/285))
		If s\size# > 2 Then s\size# = 2
		
		s\c = Int(s\c)
		
		Color s\c,s\c,s\c
		Line s\x,s\y,s\x+s\xv/2,s\y+s\yv/2;s\size#,s\size#
		
		If s\x < 0 Or s\x > GraphicsWidth() Or s\y < 0 Or s\y > GraphicsHeight() Then Delete s
	Next
	WaitTimer(timer)
	
DrawImage credit_image,70,credit_y#
		credit_y# = credit_y# - 0.5

		
		

		
		particles(512,384,Rand(255),Rand(255),Rand(255),10)
				
		
			Flip
		Wend
		credits_show = 0
		EndIf
	EndIf
EndIf


End Function


Function screenshot()

	If KeyHit(68) ;F10
	
		read_num = OpenFile("number.dat")
			If read_num = 0
				WriteFile("number.dat")
				WriteByte(read_num,screeny_num)
					Else
					screeny_num = ReadByte(read_num)
					CloseFile(read_num)
				EndIf
			
	
		SaveBuffer(FrontBuffer(),"screenshots\pong_screenshot_"+screeny_num+".bmp")
		
		screeny_num = screeny_num + 1
		
		ss_num = OpenFile("number.dat")
		WriteByte(ss_num,screeny_num)
		CloseFile(ss_num)
		
	EndIf
		
End Function 

Function boss()

	If score_diff = 0
		Cls
		boss_ini = 1
	EndIf

If boss_ini = 1 Then
DrawImage boss_intro,g_width/2-(ImageWidth(boss_intro)/2),g_height/2-(ImageHeight(boss_intro)/2)
SetFont SnapITC
Color 255,255,255
Text g_width/2,g_height/2+300,"Click the mouse to continue...",1,1
Flip
FlushMouse()
WaitMouse()

b\x = 512-(ImageWidth(ball)/2)
b\y = 384-(ImageHeight(ball)/2)

While Not KeyHit(12)
Cls

particles(b\x+(ImageWidth(ball)/2),b\y+(ImageHeight(ball)/2),0,Rand(0,255),255,2)
update_particles()
render_background()
DrawImage player,p\x,p\y,p\frame
update_player_boss()
DrawImage boss_image,boss\x,boss\y,0
update_boss()
render_ball()
ball_collisions_boss()
draw_boss_HUD()
update_ball()
pause()
controls_window()
screenshot()
credits_boss()

If KeyHit(1)
	End
EndIf

If win = 1 Then
	End
EndIf

Flip
Wend
End
EndIf

End Function
End


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;							  ;
;      PARTICLES LIBRARY	  ;
;-----------------------------;
;							  ;
;Author: Oliver Freeborn      ;
;Notes: Can create and update ;
;	    particles with ease.  ;
;		Lots of modability.   ;
; 							  ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;The type



;----------------------

;Create the particles

Function particles(pt_x,pt_y,pt_r,pt_g,pt_b,pt_a) ;params: x,y coords ; r,g,b values ; a value how long it takes to fade

	particles.particles = New particles
	
	particles\x = pt_x : particles\y = pt_y ;set the x and y postitiond
	particles\dx = Rnd(-0.5,0.5) : particles\dy = Rnd(-0.5,0.5) ;set their direction
	particles\r = pt_r : particles\g = pt_g : particles\b = pt_b ;set their colour
	particles\a# = pt_a ;set their fade speed

End Function

;-----------------------

;Update the particles

Function update_particles() ;updates all the particles that have been created

For particles.particles = Each particles ;make sure we are dealing with all the particles
			particles\x = particles\x + particles\dx ;update their x coordinate
			particles\y = particles\y + particles\dy ;update their y coordinate
			particles\a = particles\a - 0.01		 ;apply the alpha, fading speed
				If particles\a < 0 Then Delete particles ;if the particles have faded, delete them
		Next
	For particles.particles = Each particles ;get all the particles again
		Color (particles\r*particles\a),(particles\g*particles\a),(particles\b*particles\a) ;update their fade progress (colour)
		Plot particles\x,particles\y ;finally, plot them in their correct positions
Next

End Function

;------------------

Function create_lines()

While MilliSecs() < load_time

SetFont SnapITC
Text g_width/2,g_height/2+200,"Loading..."
	angle=angle+1
	Color 127*Sin(angle)+128,127*Sin(angle+64)+128,127*Sin(angle+128)+128
	
	For i = 0 To 45
		Line 200*Sin(angle+i*(num))+320,200*Cos(angle+i*(num+2))+240,200*-Sin(angle+i*(num+4))+320,200*-Cos(angle+i*(num+6))+240
	Next

	Flip
	Cls
Wend
	
End Function 


Function Distance(x1#,y1#,x2#,y2#)
	dx = x2 - x1
	dy = y2 - y1
	Return Sqr((dx^2) + (dy^2))
End Function 

Function Quadrant(x,y)
	Local gwidth = GraphicsWidth(), gheight = GraphicsHeight() 
	
	If x > gwidth/2 And y < gheight/2 ;;Top Right
		Return 1
	ElseIf x > gwidth/2 And y > gheight/2 ;;Bottom Right
		Return 2
	ElseIf x < gwidth/2 And y > gheight/2 ;;Bottom Left
		Return 3
	ElseIf x < gwidth/2 And y < gheight/2 ;;Top Left
		Return 4
	Else 
		Return 0
	EndIf
End Function  


	




	

 